c
c Point source Collimation characteristics using 
c     View Factor algorithm and
c     Single Ray  algorithm
c z-distance from collimator along its axis
c r-radius with respect to collimator axis
c All data ar in basic SI units: m
c Linear transformation ax is applied to prediction
c On contrary to previous versions point, points:
c   - no optimisation of h,a
c   - only linear transformation a*cc
c
      common ce(500),cc(500),csr(500),rv(500),zv(500)
      common /switch/isw
      character *8 file,filo,fout*7
      write(*,*)' 0-precise, 1-hopt, 2-aopt, 3-hopt+aopt'
      read(*,*)ifun
      write(*,*)' 0-old algorithms, 1-modified, 2-3R'
      read(*,*)isw
      write(fout,888)ifun,isw
888   format('poinl',i1,i1)
      write(*,*)fout
      pause
      open(3,file=fout//'.out')
      open(4,file='flist')
599   read(4,666,end=9999)file
666   format(a8)
      if(file(1:1).ne.'t'.and.file(1:1).ne.'c')stop
      write(*,666)file
      do i=1,8
         if(file(i:i).eq.' ')goto 667
      enddo
      i=9
667   last=i-1
      do j=1,8
        if(j.le.last)then
           filo(j:j)=file(j:j)
        else
           filo(j:j)='_'
        endif
      enddo
c-----
      do ibuild=1,2
      close(1)
      close(2)
      open(1, file=file(1:last)//'.dat')
      if(ibuild.eq.2)filo(8:8)='w'
      open(2, file=filo//'.out')
c
c N-points, D-diameter of colim., 
c Hmi,Hma-thickness of colim. (View Fact.alg.), Ami,Ama-attenuation
c Acmi,Acma-attenuation of collimator, hc-thickness of collimator for single ray
c UNITS-if data are in mm, UNITS=1e-3
c 
      read(1,*)n,d,hmi,hma,ami,ama,acmi,acma,hin,units
      cemax=0
      do i=1,n
        read(1,*)rv(i),zv(i),ce(i),build
c       write(*,*)i,rv(i),zv(i),ce(i),build
        rv(i)=rv(i)*units
        zv(i)=zv(i)*units
        if(ibuild.eq.2)ce(i)=ce(i)/build
        cemax=amax1(cemax,ce(i))
      enddo
c
c-----REPEAT for different norm : absolute and relative values
c
      do inorm=1,4
c-----VIEW FACTOR--------------------------------------------------------------
      write(2,10)n,inorm,ifun,isw,d,hmi,hma,ami,ama
10    format(' View-factor processing npoints=',i3,
     /' Norm=',i2,' (1-abs,2-rel,3-squares,4-squares/c) IFN=',
     /i2,' ISW=',i2/
     /' d=',f7.4,' hmi-hma',2e10.3,
     /' ami-ama=',2e10.3/)
      call optim(ifun,inorm,cemax,rv,zv,ce,cc,n,
     /      d,hmi,hma,ami,ama,acmi,acma,hin,
     /      hvf,avf,acvf,stdvf)
c-----SINGLE RAY---------------------------------------------------------------
      write(2,810)n,inorm,d,hin,ami,ama,acmi,acma
810   format(' Single Ray processing npoints=',i3,
     /' Norm of differences=',i2,' (1-abs,2-rel)'/
     /' d=',f7.4,' h=',f7.3,
     /' amin-amax(media)=',2e10.3,' amin-amax(collimator)=',2e10.3/)
      call optim(ifun+4,inorm,cemax,rv,zv,ce,csr,n,
     /      d,hmi,hma,ami,ama,acmi,acma,hin,
     /      hsr,asr,acsr,stdsr)
c-----PRINT
      write(2,602)
602   format('   r       z       Cexp       Cvie     Csr        Eps[%]')
      do i=1,n
         write(2,601)rv(i),zv(i),ce(i),cc(i),csr(i),
     /               (ce(i)-cc(i))/cemax*100,(ce(i)-csr(i))/cemax*100
601      format(2f7.3,3e10.3,2f10.0)
      enddo
      write(2,339)filo,inorm,stdvf*100,hvf,avf,stdsr*100,hsr,acsr,asr
339   format(/'Data [',a,']   Norm=',i2,
     /        '  (1-abs,2-rel,3-squares,4-squares/c)'/
     /        '     Deviation[%]      H      a(colim)     a(media)'/
     /        'VF  ',f10.2,f10.5,'      infinity',f10.2/
     /        'SR  ',f10.2,f10.5,f14.2,f10.2)
      write(3,349)filo,inorm,stdvf*100,hvf,avf,ifun,isw,
     /            filo,inorm,stdsr*100,hsr,acsr,asr
349   format(a,i3,' VF',f10.2,f10.5,'      infinity',f10.2,' IFN=',i2,
     /                                                     ' ISW=',i2/
     /       a,i3,' SR',f10.2,f10.5,f14.2,f10.2)
c
c ---norm end
      enddo
      enddo
      goto 599
9999  end

      subroutine optim(ifun,inorm,cemax,rv,zv,ce,cout,n,
     /      d,hmi,hma,ami,ama,acmi,acma,hsr,
     /      h,a,ac,std)
c
c ifun =0 VF, 1 VF h, 2 VF a, 3 VF h+a, 4 SR, 5 SR ac, 6 SR a, 7 SR a+ac
c
      dimension ce(500),cout(500),c(500),rv(500),zv(500)
      nd=10
      nd1=nd+1
      nd2=2*nd
c h,a,ac calculated parameters
      h=hsr
      a=(ami+ama)/2
      ac=(acmi+acma)/2
c dh,da,dac initial search steps
      dh=(hma-hmi)/nd2
      da=(ama-ami)/nd2
      dac=(acma-acmi)/nd2
c ihad,iad,iadc number of steps
      ihd=0
      iad=0
      iacd=0
      select case(ifun)
        case(1)
          ihd=nd
        case(2)
          iad=nd
        case(3)
          ihd=nd
          iad=nd
        case(5)
          iacd=nd
        case(6)
          iad=nd
        case(7)
          iacd=nd
          iad=nd
      end select
c
      std=1e10
      do iref=1,2
       do ih=-ihd,ihd
        do ia=-iad,iad
         do iac=-iacd,iacd
          if(ifun.le.3)then
            call cmcvf(c,zv,rv,n,d,h+ih*dh,a+ia*da)
          else
            call cmcsr(c,zv,rv,n,d,h+ih*dh,a+ia*da,ac+iac*dac)
          endif
          call norm(cemax,inorm,ce,c,c,n)
          call dif(cemax,inorm,ce,c,n,stdaux)
          if(stdaux.lt.std)then
             std=stdaux
             ihopt=ih
             iaopt=ia
             iacopt=iac
             do i=1,n
               cout(i)=c(i)
             enddo
          endif
         enddo
        enddo
       enddo
       h=amax1(dh,h+ihopt*dh)
       a=amax1(da,a+iaopt*da)
       ac=amax1(dac,ac+iacopt*dac)
       dh=dh/nd1
       da=da/nd1
       dac=dac/nd1
      enddo
      end

      subroutine cmcvf(cc,zv,rv,n,d,h,amu)
      dimension cc(500),rv(500),zv(500)
      do i=1,n
         cc(i)=colivf(zv(i),rv(i),d,h,amu)
      enddo
      end

      subroutine cmcsr(cc,zv,rv,n,d,h,amu,acmu)
      dimension cc(500),rv(500),zv(500)
      do i=1,n
         cc(i)=colisr(zv(i),rv(i),d,h,amu,acmu)
      enddo
      end

      subroutine dif(cemax,inorm,ce,cc,n,std)
      dimension ce(500),cc(500)
c INORM
c =2 relative values differences
c =1 absolute values of differences
c SMALL values are suppressed
      sum=0
      clim=cemax*1e-2
      icount=0
      do i=1,n
         if((inorm.eq.1.or.inorm.eq.3.or.ce(i).gt.clim)
     /       .and.ce(i).gt.0.)then
            icount=icount+1
            if(inorm.eq.1)then
               sum=sum+abs(ce(i)-cc(i))
            elseif(inorm.eq.2)then
               sum=sum+abs(ce(i)-cc(i))/ce(i)
            elseif(inorm.eq.3)then
               sum=sum+(ce(i)-cc(i))**2
            elseif(inorm.eq.4)then
               sum=sum+(ce(i)-cc(i))**2/ce(i)
            endif
         endif
      enddo
      if(icount.gt.0)then
         std=sum/icount
         if(inorm.eq.1)then
            std=std/cemax
         elseif(inorm.eq.3)then
            std=sqrt(std)/cemax
         elseif(inorm.eq.4)then
            std=sqrt(std/cemax)
         endif
      else
         std=-99
      endif
      end

      subroutine norm(cemax,inorm,ce,cc,cor,n)
      dimension ce(500),cc(500),cor(500),ca(500)
c
c normalisation coefficient a*cc -> cor
c
      scec=0
      sc2=0
      do i=1,n
         if(ce(i).gt.0.)then
            scec=scec+ce(i)*cc(i)
            sc2=sc2+cc(i)**2
         endif
      enddo
      a=scec/sc2
c a-is estimate based upon sum of squares.
c improvement according to specified norm
      a1=.8*a
      a2=1.2*a
      do i=1,n
         ca(i)=cc(i)*a1
      enddo
      call dif(cemax,inorm,ce,ca,n,s1)
      do i=1,n
         ca(i)=cc(i)*a2
      enddo
      call dif(cemax,inorm,ce,ca,n,s2)
      do ihalf=1,8
         a3=(a1+a2)/2.
         do i=1,n
            ca(i)=cc(i)*a3
         enddo
         call dif(cemax,inorm,ce,ca,n,s3)
         if(s2.lt.s1)then
            a1=a3
            s1=s3
         else
            a2=a3
            s2=s3
         endif
      enddo
      do i=1,n
         cor(i)=cc(i)*(a1+a2)/2
      enddo
      end

      function colivf(zs,rsgn,d,hs,amu)
      parameter (pi=3.141)
      common /switch/isw
      real l,lh,lh2
      r=abs(rsgn)
      z=amax1(zs,1e-6)
      h=amax1(hs,1e-4)
c
c Inputs:
c z-distance of plane (in meters)
c r-radius
c d-aperture
c h-thickness of collimator
c amu-attenuation (=rho * mu)
c
      r1=d/2
      r2=r1*(h+z)/z
      r12=r1*r1
      r22=r2*r2
      e=h*r/z
      l=sqrt(z**2+r**2)
      zh=z+h
      lh2=zh**2+r**2
      lh=sqrt(lh2)
      if(e.ge.r1+r2)then
         s=0
      elseif(e.le.r2-r1)then
         s=pi*r12
      elseif(e.ge.sqrt(r22-r12))then
         b=sqrt(amax1(0.,4*r12*r22-(e**2-r12-r22)**2))/2
         ber1=b/(e*r1)
         ber2=b/(e*r2)
         s=r12*asin(ber1)+r22*asin(ber2)-b
      else
         b=sqrt(amax1(0.,4*r12*r22-(e**2-r12-r22)**2))/2
         ber1=b/(e*r1)
         ber2=b/(e*r2)
         s=r12*(pi-asin(ber1))+r22*asin(ber2)-b
      endif
      if(isw.eq.0)then
         colivf=s*zh*exp(-amu*l)/(4*pi*lh**3)
      else
         colivf=s*zh*exp(-amu*l)/(2*pi*r12)*(1./lh-1./sqrt(lh2+r12))
      endif
      end  

      function colisr(zs,rsgn,d,hs,amu,acol)
c 
c Modified 3R algorithm 
c
      parameter (pi=3.141)
      common /switch/isw
      real lh,lh2,l1,l2,lm1,lm2,lc1,lc2
      r=abs(rsgn)
      z=amax1(zs,1e-6)
      h=amax1(hs,1e-4)
c
c Inputs:
c z-distance of plane (in meters)
c r-radius
c d-aperture
c h-thickness of collimator
c amu-attenuation of media (=rho * mu)
c acol-attenuation of collimator (=rho * mucol)
c
      r1=d/2
      r12=r1**2
      e=h*r/z
      zh=z+h
      lh2=zh**2+r**2
      lh=sqrt(lh2)
      rlm=sqrt((r-r*h/zh)**2+(h-zh)**2)
      if(r/zh.le.r1/h)then
         rlc=0
      else
         rlc=sqrt((r1-r*h/zh)**2+(h-zh*r1/r)**2)
      endif
      if(isw.eq.0)then
         colisr=zh*exp(-amu*rlm-acol*rlc)/(4*pi*lh**3)
      else
         colisr=zh*exp(-amu*rlm-acol*rlc)/2*
     /       (1./lh-1./sqrt(lh2+r12))
      endif
      if(isw.eq.2)then
c fixed diameter of detector
         det=0.05
         br=(det+d)/4
         ds=pi*(det**2-d**2)/8
         l1=sqrt((br-r)**2+zh**2)
         l2=sqrt((br+r)**2+zh**2)
         lm1=l1*(1-h/zh)
         lm2=l2*(1-h/zh)
         if(r.lt.br)then
           lc1=l1*amin1(h/zh,(br-d/2)/(br-r))
         else
           lc1=l1*h/zh
         endif
         lc2=l2*amin1(h/zh,(br-d/2)/(br+r))
         col=ds*zh/(4*pi)*(exp(-amu*lm1-acol*lc1)/l1**3+
     /                               exp(-amu*lm2-acol*lc2)/l2**3)
         colisr=colisr+col
      endif
      end  
